
RANDOMIZE TIMER 'set the seed of the randomizer to the current number of seconds since midnight
SCREEN 7, 1, 0, 1 'use screen 7 mode (320x200 @256 colors with 7 pages of memory), use color mode, set memory page as 0 for drawing, and set memory page 1 as the selected

CONST SWIDTH  = 320
CONST SHEIGHT = 200

CONST spherecount = 4
CONST starcount = 100

DIM angle AS SINGLE

' data type for all spheres (suns, planets, gas giants, moons, satellites, ect)
TYPE sphere
    cordinateX AS SINGLE 'x
    cordinateY AS SINGLE 'y
    cordinateZ AS SINGLE 'z
    radius AS INTEGER 'radius of circle
    colors AS INTEGER '0 to 16
    rotationoffset AS SINGLE 'saved as degrees
    parent AS INTEGER ' relationship
    direction AS INTEGER ' clockwise or counter-clockwise
    angularvelocity AS SINGLE ' allow for different rotation speeds
END TYPE
DIM spheres(spherecount) AS sphere

'sample data
spheres(0).radius = 5
spheres(0).parent = -1
spheres(0).direction = 1
spheres(0).colors = 11
spheres(0).angularvelocity = .25

spheres(1).radius = 2
spheres(1).parent = 0
spheres(1).direction = 1
spheres(1).colors = 12
spheres(1).angularvelocity = 4

spheres(2).radius = 3.3
spheres(2).parent = -1
spheres(2).rotationoffset = 60
spheres(2).direction = 1
spheres(2).colors = 13
spheres(2).angularvelocity = 1


spheres(3).radius = 4
spheres(3).parent = -1
spheres(3).rotationoffset = 180
spheres(3).direction = -1
spheres(3).colors = 14
spheres(3).angularvelocity = 2


spheres(4).radius = 6
spheres(4).parent = -1
spheres(4).rotationoffset = -300
spheres(4).direction = 1
spheres(4).colors = 6
spheres(4).angularvelocity = 1.3

TYPE star
    x AS INTEGER
    y AS INTEGER
    c AS INTEGER
END TYPE
DIM stars(starcount) AS star

FOR i% = 0 TO starcount
    stars(i%).x = (RND * 320) + 1
    stars(i%).y = (RND * 200) + 1
    stars(i%).c = (RND * 1) + 7
NEXT i%


' main loop
DO
    ' draw background
    FOR i% = 0 TO starcount
        PSET (stars(i%).x, stars(i%).y), stars(i%).c
    NEXT i%

    COLOR 15 'set colors as WHITE for text/graphics
    LOCATE 3, 17 'set text cursor to x,y
    PRINT TIME$ ' print the current time

    'LOCATE 5, 17
    'PRINT angle

    ' draw the sun
    COLOR 14
    CIRCLE (SWIDTH  / 2, SHEIGHT / 2), 10, , , , 1
    PAINT STEP(0, 0), 14, 14

    ' update the global rotation angle
    angle = angle + 0.01
    IF angle > 360 THEN angle = 0

    FOR i% = 0 TO spherecount

        ' does this sphere have a parent?
        IF spheres(i%).parent <> -1 THEN

            ' draw path of the orbit near the parent
            COLOR 2 '0 is black, 2 is green, 7 is light gray, 8 is dark gray, 15 is white
            CIRCLE (spheres(spheres(i%).parent).cordinateX, spheres(spheres(i%).parent).cordinateY), 8 * spheres(i%).radius, , , , 1 ' draw circle(x,y),radius,,,,aspect ratio

            ' calculate the position of the sphere near the parent
            x = (spheres(spheres(i%).parent).cordinateX) + (COS(angle * spheres(i%).angularvelocity + spheres(i%).rotationoffset) * (8 * spheres(i%).radius))
            y = (spheres(spheres(i%).parent).cordinateY) + (SIN(angle * spheres(i%).angularvelocity + spheres(i%).rotationoffset) * (8 * spheres(i%).radius))
            r = spheres(i%).radius

        ELSE

            ' draw path of orbit
            'COLOR INT(RND * 6) + 1 ' change the colors from 1 to 6 (out of 16 possible)
            COLOR 2
            CIRCLE (SWIDTH  / 2, SHEIGHT / 2), SHEIGHT / spheres(i%).radius, , , , 1 ' draw circle(x,y),radius,,,,aspect ratio

            ' calculate the position of the sphere
            x = (SWIDTH  / 2) + (COS(spheres(i%).direction * angle * spheres(i%).angularvelocity + spheres(i%).rotationoffset) * (SHEIGHT / spheres(i%).radius))
            y = (SHEIGHT / 2) + (SIN(spheres(i%).direction * angle * spheres(i%).angularvelocity + spheres(i%).rotationoffset) * (SHEIGHT / spheres(i%).radius))
            r = spheres(i%).radius
        END IF

        ' save the position of the sphere (for the children)
        spheres(i%).cordinateX = x
        spheres(i%).cordinateY = y

        ' draw sphere
        COLOR spheres(i%).colors '11 '10
        CIRCLE (x, y), r, , , , 1
        PAINT STEP(0, 0), spheres(i%).colors, spheres(i%).colors

    NEXT i%


    PCOPY 0, 1 'copy/flip the video memory page from 0 to 1 (so we can see what we have drawn without watching the drawing itself)
    CLS

LOOP UNTIL INKEY$ <> ""

